---
title: Performance budgets
slug: Web/Performance/Performance_budgets
tags:
  - Budget
  - Performance
  - Performance Budget
  - Web Performance
---
<p>{{draft}}</p>

<p><span class="seoSummary">A performance budget is a limit to prevent regressions. It can apply to a file, a file type, all files loaded on a page, a specific metric (e.g. <a href="/en-US/docs/Glossary/Time_to_interactive">Time to Interactive</a>), a custom metric (e.g. Time to Hero Element), or a threshold over a period of time.   </span></p>

<h2 id="Why_do_I_need_a_performance_budget">Why do I need a performance budget?</h2>

<p>A budget exists to reflect your reachable goals. It's a tradeoff between user experience, against other performance indicators (e.g. conversion rate).<br>
 <br>
 These goals can be:</p>

<ul>
 <li>Timing based (e.g. <a href="/en-US/docs/Glossary/Time_to_interactive">Time to Interactive</a>, <a href="/en-US/docs/Glossary/First_contentful_paint">First Contentful Paint</a>).</li>
 <li>Quantity-based (e.g. amount of JS files/total image size).</li>
 <li>Rule-based (e.g. Pagespeed index, Lighthouse score).</li>
</ul>

<p>Their primary goal is to prevent regressions, but they can provide insights to forecast trends (i.e. On September, 50% of the budget was spent in a week).</p>

<p>Additionally, it can uncover development needs (i.e. A large library with smaller alternatives is often picked to solve a common problem).</p>

<h2 id="How_do_I_define_a_performance_budget">How do I define a performance budget?</h2>

<p>A budget should include 2 levels:</p>

<ul>
 <li>Warning.</li>
 <li>Error.</li>
</ul>

<p>The warning level allows you to be proactive and plan any tech debt, while not blocking development or deploys.</p>

<p>The error level is an upper bound limit, where changes will have a negative and noticeable impact.</p>

<p>In order to begin, you need to first measure the devices and connection speeds where your users are coming from (e.g. A ~$<em>200 </em>Android device over a 3G connection), using multiple <a href="/en-US/docs/Learn/Performance/Web_Performance_Basics">tools</a>. These time-based metrics will translate into file-size budgets.</p>

<p>A default baseline to reduce bounce rate is to achieve <a href="https://infrequently.org/2017/10/can-you-afford-it-real-world-web-performance-budgets/">Time to Interactive under 5 seconds in 3G/4G, and under 2 seconds for subsequent loads</a>. However, based on the specific goals and content of your site, you might choose to focus on other metrics.</p>

<p>For a text-heavy site such as a blog or a news site, the <a href="/en-US/docs/Glossary/First_contentful_paint">First Contentful Paint</a> metric could reflect more closely the user behavior. (i.e. How fast can users start reading), which will inform file specific budgets (e.g. Font size), and their optimizations. (e.g. Using <a href="/en-US/docs/Web/CSS/@font-face/font-display">font-display</a> to improve <a href="/en-US/docs/Learn/Performance/perceived_performance">Perceived Performance</a>).</p>

<p>The ultimate value of a Performance Budget is to correlate the impact of Performance on business or product goals. When defining metrics, you should focus on <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/User_experience_best_practices">User Experience</a>, which will dictate not only the bounce or conversion rate but how likely is that user to return.</p>

<h2 id="How_do_I_implement_a_performance_budget">How do I implement a performance budget?</h2>

<p>During development, there are a few tools to run checks against new or modified assets:</p>

<ul>
 <li>A module bundler (e.g. <a href="https://webpack.js.org/">webpack</a>), has <a href="https://webpack.js.org/configuration/performance/">performance features</a> that will notify you when assets exceed specified limits.</li>
 <li><a href="https://github.com/siddharthkp/bundlesize">Bundlesize</a>, allows you to define and run file size checks in your <a href="/en-US/docs/Mozilla/Continuous_integration">CI</a> pipeline.</li>
</ul>

<p>File size checks are the first line of defense against regressions but translating size back into time metrics can be difficult since development environments could be missing 3rd party scripts, and optimizations commonly provided by a <a href="/en-US/docs/Glossary/CDN">CDN</a>.</p>

<p>The first step is to define a development baseline for each branch to compare to and the precision of the difference between development and production can be used as a goal towards better match the live environment.</p>

<p>The <a href="https://github.com/GoogleChromeLabs/lighthousebot">Lighthouse Bot</a> integrates with <a href="https://travis-ci.org/">Travis CI</a> and can be used to gather <a href="https://developers.google.com/web/tools/lighthouse/">Lighthouse</a> and <a href="https://webpagetest.org">Webpage Test</a> metrics from a development URL. The bot will pass or fail based on the provided minimum scores.</p>

<h2 id="How_do_I_enforce_a_performance_budget">How do I enforce a performance budget?</h2>

<p>The sooner that you can identify a potential addition pushing the budget, the better you can analyze the current state of your site, and pinpoint optimizations or unnecessary code.</p>

<p>However, you should have multiple budgets and be dynamic. They are meant to reflect your ongoing goals but allow risks and experiments. For example, you may introduce a feature that increases overall load time but attempts to increase user engagement. (i.e. How long a user stays on a page or site).</p>

<p>A performance budget helps you protect optimal behavior for your current users while enabling you to tap into new markets and deliver custom experiences.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://addyosmani.com/blog/performance-budgets/">Start Performance Budgeting</a> by Addy Osmani</li>
 <li><a href="https://web.dev/fast/performance-budgets-101">Performance Budgets 101</a> by Milica Mihajlija</li>
 <li><a href="https://timkadlec.com/remembers/2019-03-07-performance-budgets-that-stick/">Performance Budgets That Stick</a> by Tim Kadlec</li>
</ul>
